' Windows Script Host Sample Script
'
' ------------------------------------------------------------------------
'               Copyright (C) Software Bisque
'
' ------------------------------------------------------------------------
Option Explicit

Const L_Welcome_MsgBox_Message_Text    = "This script demonstrates how cause a dome to track along with a telescope.  It assumes the dome and telescope are coupled in TheSky.  You can specify the alignment interval within the script."
Const L_Welcome_MsgBox_Title_Text      = "Windows Scripting Host Sample"
Const szTitle		="DomeTrack"


Dim CRLF
CRLF = Chr(13) & Chr(10)

Const AlignSeconds		= 30				'The number of seconds to elapse before alignment occurs
Const bIgnoreErrors		= True				'Set to True (default is False) to have the script continue running on *all* errors except user abort

Call Welcome()
Call Main()

Sub PromptOnError(bErrorOccurred)

	Dim bExitScript

	bErrorOccurred = False
	bExitScript = False

	if (bIgnoreErrors = True) then 
		'Ignore all errors except when the user Aborts
		if (CStr(Hex(Err.Number)) = "800404BC") then 
			'Do nothing and let the user abort
		else
			Err.Clear
		end if
	end if


	if (Err.Number = 0) then 
		'Do nothing
	else
		bErrorOccurred = True
		bExitScript = MsgBox ("An error has occurred running this script.  Error # " & CStr(Hex(Err.Number)) & " " & Err.Description + CRLF + CRLF + "Exit Script?", vbYesNo + vbInformation)
	end if

	If bExitScript = vbYes Then
		WScript.Quit
	else
		Err.Clear
	End if 

End Sub

    
' ********************************************************************************
' *
' * Sample
' *
Sub Main()
	Dim objTheSky
	Dim objWnd
	Dim Dur
	Dim szMark
	Dim bErrorOccurred
	On Error Resume Next
	
	Set objTheSky = WScript.CreateObject("TheSky.Raven.1")
	Set ObjWnd = WScript.CreateObject("VBUtils.ModelessWnd")

	ObjWnd.Create()
	ObjWnd.SetCaption(szTitle)

	
	szMark = Now()

	Do
		bErrorOccurred = FALSE 'No error has occurred

		Dur = DateDiff("s",szMark,Now())

		Call objWnd.SetText(1, "The dome will slew to the telescope in")
		Call objWnd.SetText(2, CStr(AlignSeconds-Dur) + " seconds.")

		if (Dur>=AlignSeconds) then 

			Call objWnd.SetText(1, "Slew in progress.")
			Call objWnd.SetText(2, "")

			Call objTheSky.SlewDomeToTelescope()

			Call PromptOnError(bErrorOccurred)

			objWnd.Sleep(1)

			szMark = Now()
		end if
			
		if (ObjWnd.Aborted) then
			Call PromptOnError(bErrorOccurred)
		end if	

		objWnd.Sleep(1)

	Loop  

	ObjWnd.Destroy()
	Set objWnd = Nothing
	Set objTheSky = Nothing

End Sub


' ********************************************************************************
' *
' * Welcome
' *
Sub Welcome()
    Dim intDoIt

    intDoIt =  MsgBox(L_Welcome_MsgBox_Message_Text, _
                      vbOKCancel + vbInformation,    _
                      L_Welcome_MsgBox_Title_Text )
    If intDoIt = vbCancel Then
        WScript.Quit
    End If
End Sub

