' Windows Script Host Sample Script
'
' ------------------------------------------------------------------------
'               Copyright (C) Software Bisque
'
' ------------------------------------------------------------------------
Option Explicit

Dim  L_Welcome_MsgBox_Message_Text    
Dim	 L_Title_Text

L_Welcome_MsgBox_Message_Text	= "This script demonstrates how track a particular spot on the Moon using TheSky and the Paramount ME."
L_Title_Text					= "Track Moon"


Const TheSkyWidth	= 640
Const TheSkyHeight	= 480
Const TheSkyFOV		= 1.0
Const SlewEvery		= 5


'Use TheSky.Web to recompute the moons position
'Requires a run-time license to create a TheSky.Web object
Sub ForceTheSkyToRecomputeMoon(TS)

	Const USETHESKYS = -999.0
	Const Command = 14

	Dim TheSkyWeb 
	Dim Folder
	Dim GIFFileName

	'We need a starting point
	TS.GetObjectAzAlt("Moon")

	Set TheSkyWeb = CreateObject("TheSky.Web")
	Folder = "C:\"

	TheSkyWeb.CurAz = TS.dObjectRa
	TheSkyWeb.CurAlt = TS.dObjectDec
	TheSkyWeb.CurFOV = TheSkyFOV

	GIFFileName = TheSkyWeb.CreateStarChart(USETHESKYS, Command, 100, USETHESKYS, USETHESKYS, USETHESKYS, TheSkyWidth, TheSkyHeight, Folder)
	'MsgBox("Star Chart Successfull (" + GIFFileName + ")  ")
	Set TheSkyWeb = Nothing

End Sub    

Sub PromptUser()
    Dim intDoIt

    intDoIt =  MsgBox("This script will track a spot on the moon.  Position the telescope to the desired spot on the moon now and press OK to begin tracking.", _
                      vbOKCancel + vbInformation,    _
                      L_Title_Text)
    If intDoIt = vbCancel Then
        WScript.Quit
    End If
End Sub


Function Within24(Diff)

	if (Diff>12) then
		Diff = 24-Diff
	end if

	if (Diff<-12) then
		Diff = 24+Diff
	end if

	Within24 = Diff

End Function

' ********************************************************************************
' *
' * Main
' *
Sub Main
	Dim objTele
	Dim objTheSky
	Dim objWnd
	Dim Msg
	Dim dDeltaRa
	Dim dDeltaDec
	
	'Create objects
	Set objTele = WScript.CreateObject("RASCOM.RASCOMTele.1")
	Set objTheSky = WScript.CreateObject("RASCOM.RASCOMTheSky.1")
	Set ObjWnd = WScript.CreateObject("VBUtils.ModelessWnd")

	'Connect 
	objTele.Connect()
	ObjTheSky.Connect()

	'See if tele connection failed
	if (objTele.IsConnected = 0) then
		MsgBox("Connection failed.")
		WScript.Quit
	end if

	PromptUser


	'Recompute the moons position
	Call ForceTheSkyToRecomputeMoon(objTheSky)

	'Get the moon's position
	objTheSky.GetObjectRaDec("Moon")
	'Msg = "Moon Ra,Dec =" + CStr(objTheSky.dObjectRa) + "," + CStr(objTheSky.dObjectDec)
	'MsgBox(Msg)
	
	'Get the current telescope's position 
	objTele.GetRaDec()
	'Msg = "Tele Ra,Dec =" + CStr(objTele.dRa) + "," + CStr(objTele.dDec)
	'MsgBox(Msg)

	dDeltaRa = 	Within24(objTheSky.dObjectRa-objTele.dRa)
	dDeltaDec = objTheSky.dObjectDec-objTele.dDec
	Msg = "Delta Ra,Dec =" + CStr(dDeltaRa) + "," + CStr(dDeltaDec)
	MsgBox(Msg)

	ObjWnd.Create()
	ObjWnd.SetCaption(L_Title_Text)

	do
		Call objWnd.SetText(1, "Slewing to desired spot on the moon...")

		'Update TheSky's moon position
		Call ForceTheSkyToRecomputeMoon(objTheSky)

		objTheSky.GetObjectRaDec("Moon")

		'Goto the offset position
		Call objTele.SlewToRaDec(objTheSky.dObjectRa-dDeltaRa,objTheSky.dObjectDec-dDeltaDec,L_Title_Text)

		Call objWnd.SetText(1, "Idle.")

		if (ObjWnd.Aborted) then
			WScript.Quit
		end if	

		objWnd.Sleep(SlewEvery)

	Loop

End Sub


Call Main()
